%define use_gitsnap 0
%{?_no_gitsnap: %{expand: %%global use_gitsnap 0}}
%if %{use_gitsnap}
%define gitsnap 200809231700
%endif

# disable the requires on gnome-python-gnomekeyring when it's not avaialable
# gnome-python-desktop requires s-c-p indirectly and the build fails otherwise
%define pygnomekeyring 1

Summary:	A printer administration tool
Name:		system-config-printer
Version:	1.4.2
Release:	15
License:	LGPLv2+
Group:		System/Configuration/Printing
Url:		http://cyberelk.net/tim/software/system-config-printer/
Source0:	http://cyberelk.net/tim/data/system-config-printer/1.3/%{name}-%{version}%{?gitsnap:-%gitsnap}.tar.xz
Source1:	system-config-printer.pam
Source2:	system-config-printer.console
Source3:	po-mdv.tar.bz2
Source4:	mdv_printer_custom.py
Source5:	hp-makeuri-mdv.c
Source6:	mdv_backend
Patch0:		system-config-printer-1.4.2-mdv_custom-applet.patch
Patch2:		system-config-printer-1.4.2-mdv_custom-system-config-printer.patch
Patch3:		system-config-printer-1.3.1-start-applet.patch
Patch4:		system-config-printer-1.3.12-udev-configure-printer-mdv.patch
Patch5:		system-config-printer-1.4.2-mdv_custom-embedded_window.patch
# Fedora patches
Patch200:	system-config-printer-no-job-notifications.patch
Patch203:	system-config-printer-systemd.patch
# Mageia patches
Patch300:	system-config-printer-1.3.7-remove-Brother-HL-2030-blacklist.patch

BuildRequires:	desktop-file-utils
BuildRequires:	docbook-dtd412-xml
BuildRequires:	docbook-style-xsl
BuildRequires:	intltool
BuildRequires:	systemd-units
BuildRequires:	xmlto

BuildRequires:	cups-devel
BuildRequires:	gettext-devel
BuildRequires:	libhpip-devel
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(dbus-glib-1)
BuildRequires:	pkgconfig(libudev)
BuildRequires:	pkgconfig(libusb)
BuildRequires:	pkgconfig(python)
# (cg) Required for CheckUSBPermissions.py
Requires:	acl
Requires:	dbus-x11
Requires:	desktop-file-utils
Requires:	gnome-icon-theme
Requires:	gnome-python
Requires:	gnome-python-desktop
%if %{pygnomekeyring}
Requires:	gnome-python-gnomekeyring
%endif
Requires:	hplip-model-data
Requires:	libxml2-python
# nmap is required to scan the network, just like printerdrake used to do
Requires:	nmap
Requires:	python-cups
Requires:	python-curl
Requires:	python-dbus
Requires:	python-gi
Requires:	python-gobject
Requires:	python-pyinotify
Requires:	python-smbc
Requires:	system-config-printer-libs = %{EVRD}
Requires:	system-config-printer-udev = %{EVRD}
Requires:	virtual-notification-daemon
#For non GTK3 system
Requires:	canberra-gtk
Requires:	%{_lib}gtk-gir3.0
Requires:	typelib(Atk)
Requires:	typelib(GdkPixbuf)
Requires:	typelib(Gio)
Requires:	typelib(Notify)
Suggests:	samba-client

%description
system-config-printer is a graphical user interface that allows
the user to configure a CUPS print server.

%files
%doc ChangeLog README
%{_bindir}/%{name}
%{_bindir}/scp-dbus-service
%{_sbindir}/%{name}
#{_bindir}/hp-makeuri-mdv
%{_bindir}/%{name}-applet
%{_bindir}/install-printerdriver
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/ui
%dir %{_datadir}/%{name}/xml
%{_datadir}/%{name}/*.py*
%{_datadir}/%{name}/troubleshoot
%{_datadir}/%{name}/ui/*.ui
%{_datadir}/%{name}/xml/*
%{_datadir}/%{name}/icons
%{_datadir}/applications/system-config-printer.desktop
#%{_datadir}/applications/manage-print-jobs.desktop
%{_sysconfdir}/xdg/autostart/print-applet.desktop
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%config(noreplace) %{_sysconfdir}/security/console.apps/%{name}
%{_mandir}/man1/*

#---------------------------------------------------------------------

%package udev
Summary:	Rules for udev for automatic configuration of USB printers
Group:		System/Configuration/Hardware
Requires:	system-config-printer-libs = %{EVRD}
Requires(post,preun):	rpm-helper
Obsoletes:	hal-cups-utils <= 0.6.20
Conflicts:	cups < 1.4.2-6

%description udev
The udev rules and helper programs for automatically configuring USB
printers.

%post
# disable old printer detection system
if [ -f /etc/sysconfig/printing ]; then
    if grep -q ^AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=.*/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no/g' /etc/sysconfig/printing
    else
        echo AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    fi
    if grep -q ^ENABLE_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/ENABLE_QUEUES_ON_PRINTER_CONNECTED=.*/ENABLE_QUEUES_ON_PRINTER_CONNECTED=no/g' /etc/sysconfig/printing
    else
        echo ENABLE_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    fi
else
    echo AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    echo ENABLE_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
fi

%postun
# enable old printer detection system
if [ -f /etc/sysconfig/printing ]; then
    if grep -q ^AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=.*/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=yes/g' /etc/sysconfig/printing
    fi
    if grep -q ^ENABLE_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/ENABLE_QUEUES_ON_PRINTER_CONNECTED=.*/ENABLE_QUEUES_ON_PRINTER_CONNECTED=yes/g' /etc/sysconfig/printing
    fi
fi

%files udev
/lib/udev/udev-add-printer
/lib/udev/udev-configure-printer
/lib/udev/rules.d/70-printers.rules
/lib/systemd/system/configure-printer.service

#---------------------------------------------------------------------

%package  libs
Summary:  Common code for the graphical and non-graphical pieces
Group:    System/Libraries 
Requires: python
Requires: foomatic
Requires: python-cups

%description libs
The common code used by both the graphical and non-graphical parts of
the configuration tool.

%files libs -f system-config-printer.lang
%dir %{_sysconfdir}/cupshelpers/
%config(noreplace) %{_sysconfdir}/cupshelpers/preferreddrivers.xml
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.redhat.NewPrinterNotification.conf
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.redhat.PrinterDriversInstaller.conf
%config(noreplace) %{_datadir}/dbus-1/interfaces/org.fedoraproject.Config.Printing.xml
%config(noreplace) %{_datadir}/dbus-1/services/org.fedoraproject.Config.Printing.service
%dir %{python_sitelib}/cupshelpers
%{python_sitelib}/cupshelpers/__init__.py*
%{python_sitelib}/cupshelpers/cupshelpers.py*
%{python_sitelib}/cupshelpers/openprinting.py*
%{python_sitelib}/cupshelpers/ppds.py*
%{python_sitelib}/cupshelpers/config.py*
%{python_sitelib}/cupshelpers/installdriver.py*
%{python_sitelib}/cupshelpers/xmldriverprefs.py*
%{_prefix}/lib/cups/backend/mdv_backend
%{py_platsitedir}/mdv_printer_custom.py*
%{python_sitelib}/*.egg-info

#--------------------------------------------------------------------

%prep
%setup -q
%apply_patches

# update mdv custom translation
tar xvjf %{SOURCE3}
pushd po
for i in *.po; do
    if [ ! -f ../po-mdv/$i ]; then
        continue
    fi
    msgcat $i ../po-mdv/$i > ../po-mdv/$i-new
    rm -f $i
    mv ../po-mdv/$i-new $i
done
popd

autoreconf -fi

%build
%if %{use_gitsnap}
./bootstrap
%endif

%configure2_5x \
	--with-systemdsystemunitdir=%{_unitdir} \
	--with-udev-rules

make
# (salem) this hack avoids requiring hplip
gcc %{SOURCE5} -o hp-makeuri-mdv -lhpmud

%install
%makeinstall_std udevrulesdir=/lib/udev/rules.d  udevhelperdir=/lib/udev

mkdir -p %{buildroot}%{_mozillaextpath}
mkdir -p %{buildroot}%{py_platsitedir}
mkdir -p %{buildroot}%{_bindir}
#cp -f hp-makeuri-mdv %{buildroot}%{_bindir}
# Make sure pyc files are generated, otherwise we can get
# difficult to debug problems
pushd %{buildroot}%{_datadir}/%{name}
python -m compileall .
popd
mkdir -p %{buildroot}%{py_platsitedir}
cp -fv %{SOURCE4} %{buildroot}%{py_platsitedir}
pushd %{buildroot}%{py_platsitedir}
python -m compileall .
popd

mkdir -p %{buildroot}%{_prefix}/lib/cups/backend
cp -f %{SOURCE6} %{buildroot}%{_prefix}/lib/cups/backend

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
install -p -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/pam.d/%{name}
install -p -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/security/console.apps/%{name}
mv %{buildroot}%{_bindir}/%{name} %{buildroot}%{_sbindir}/%{name}
ln -s consolehelper %{buildroot}%{_bindir}/%{name}

#rename service
mv -f %{buildroot}%{_unitdir}/configure-printer@.service %{buildroot}%{_unitdir}/configure-printer.service

%find_lang system-config-printer


%changelog
* Wed Sep 03 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.4.2-15
+ Revision: c7ad16e
- Fix typo

* Wed Sep 03 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.4.2-15
+ Revision: 84e4fcd
- Update Requires

* Wed Sep 03 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.4.2-15
+ Revision: a618cb5
- Spec cleanup

* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.2-14
+ Revision: 65ce753
- MassBuild#440: Increase release tag

* Sat Nov 23 2013 Alexander Kazancev <kazancas@gmail.com> 1.4.2-13
+ Revision: 2563fb0
- Add requires for %{_lib}gtk-gir3.0

* Fri Nov 22 2013 akdengi <alexander.kazancev@rosalab.ru> 1.4.2-12
+ Revision: 693d14f
- fix mdv custom add with GTK3+

* Thu Nov 21 2013 akdengi <alexander.kazancev@rosalab.ru> 1.4.2-11
+ Revision: a9d44e4
- fix run on non-GTK3 system

* Thu Nov 21 2013 akdengi <alexander.kazancev@rosalab.ru> 1.4.2-10
+ Revision: 9a8c290
- fix requires

* Thu Nov 21 2013 akdengi <alexander.kazancev@rosalab.ru> 1.4.2-10
+ Revision: e6f2c4e
- fix patches

* Wed Nov 13 2013 Alexander Kazancev <kazancas@gmail.com> 1.4.2-9
+ Revision: 660ab65
- Updated system-config-printer.pam

* Sun Nov 10 2013 Alexander Kazancev <kazancas@gmail.com> 1.4.2-9
+ Revision: 87b9d68
- SILENT Fix files

* Sun Nov 10 2013 akdengi <kazancas@mandriva.ru> 1.4.2-9
+ Revision: 9b41a76
- add needing gir notify BR

* Sun Nov 10 2013 akdengi <kazancas@mandriva.ru> 1.4.2-9
+ Revision: 3e24346
- SILENT rediff cups version patch

* Sun Nov 10 2013 akdengi <kazancas@mandriva.ru> 1.4.2-9
+ Revision: 23f34c6
- SILENT return CUPS version patch

* Sun Nov 10 2013 akdengi <kazancas@mandriva.ru> 1.4.2-9
+ Revision: addc101
- SILENT fix patches

* Sun Nov 10 2013 akdengi <kazancas@mandriva.ru> 1.4.2-9
+ Revision: 59d33e9
- SILENT fix spec

* Sun Nov 10 2013 akdengi <kazancas@mandriva.ru> 1.4.2-9
+ Revision: ef59317
- update to 1.4.2 from upstream + Mageia

* Fri Dec 28 2012 Denis Silakov <denis.silakov@rosalab.ru> 1.3.12-11
+ Revision: 20d276c
- LOG Added Russian translation for windo title

* Thu Dec 20 2012 Denis Silakov <denis.silakov@rosalab.ru> 1.3.12-10
+ Revision: 5f00df5
- Added Russian localization for .desktop file

* Fri Nov 30 2012 Alexander Kazancev <kazancas@gmail.com> 1.3.12-9
+ Revision: 1ef3c58
- Updated system-config-printer.spec

* Wed Nov 28 2012 akdengi <kazancas@mandriva.ru> 1.3.12-8
+ Revision: 2d6624c
- fix files

* Wed Nov 28 2012 akdengi <kazancas@mandriva.ru> 1.3.12-8
+ Revision: 11c663b
- some fix

* Wed Nov 28 2012 akdengi <kazancas@mandriva.ru> 1.3.12-8
+ Revision: 082dcff
- some fix

* Tue Nov 27 2012 akdengi <kazancas@gmail.com> 1.3.12-8
+ Revision: 792e8da
- fix

* Tue Nov 27 2012 akdengi <kazancas@gmail.com> 1.3.12-8
+ Revision: 916e27b
- restore mandriva stuff

* Sun Nov 25 2012 Arkady Shane <ashejn@gmail.com> 1.3.12-6
+ Revision: 97e9458
- added R: typelib(PackageKitGlib)

* Sat Nov 24 2012 Alexander Kazancev <kazancas@gmail.com> 1.3.12-5
+ Revision: 6eee618
- Updated system-config-printer.spec

* Sat Nov 24 2012 Alexander Kazancev <kazancas@gmail.com> 
+ Revision: 250a130
- Updated system-config-printer.spec

* Sat Nov 24 2012 akdengi <kazancas@gmail.com> 1.3.12-4
+ Revision: 22778ac
- fix applet

* Sat Nov 24 2012 akdengi <kazancas@gmail.com> 1.3.12-4
+ Revision: fcba8ba
- latest fix


